version: '3'
services:
  publicnode:
    image: ethereum/client-go:alpine
    ports:
    - 8590:8545
    command: --dev --rpc --rpcaddr 0.0.0.0 --rpcvhosts "*" --ws --wsaddr 0.0.0.0 --wsorigins "*" --datadir /tmp
    networks: 
    - privacynet

  privacynode1:
    image: registry.gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-privacy:latest
    ports:
    - 8546:8545
    command: --config /privacy/conf/default-conf.json --rpcaddr privacynode1 --publicnode.account 0x1778fef1adf67b8d904a73f64da4d29c1f13ec0b --publicnode.address $SMARTCONTRACT_ADDRESS
    volumes:
    - ./node1/keystore:/data/keystore
    - .:/privacy/conf
    links:
    - publicnode
    depends_on:
    - publicnode
    networks: 
    - privacynet


  privacynode2:
    image: registry.gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-privacy:latest
    ports:
    - 8547:8545
    command: --config /privacy/conf/default-conf.json --rpcaddr privacynode2 --publicnode.account 0x63692126553a7100c4faa2b78d36b2757fe98d5e --publicnode.address $SMARTCONTRACT_ADDRESS
    volumes:
    - ./node2/keystore:/data/keystore
    - .:/privacy/conf
    links:
    - publicnode
    depends_on:
    - publicnode
    networks: 
    - privacynet

  privacynode3:
    image: registry.gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-privacy:latest
    ports:
    - 8548:8545
    command: --config /privacy/conf/default-conf.json --rpcaddr privacynode3 --publicnode.account 0x663684a188d5f751f286c991f3704b478cec422e --publicnode.address $SMARTCONTRACT_ADDRESS
    volumes:
    - ./node3/keystore:/data/keystore
    - .:/privacy/conf
    links:
    - publicnode
    depends_on:
    - publicnode
    networks: 
    - privacynet

networks: 
  privacynet: